.TH UQWK 1
.IX uqwk
.IX qwk
.SH NAME
uqwk - Collect news and mail into QWK packet
.SH SYNOPSIS
.B
uqwk
.RB [options]
.SH DESCRIPTION
.B uqwk
is a program which collects all a user's unread mail or news
and formats it into something called a "QWK" packet, which is then
downloaded.  Mail and News can then be read offline, saving phone
charges.  QWK readers exist for almost every machine.
.PP
.B uqwk
also accepts reply packets, so replies can be mailed (if your
mailer understands "mail -s"), or posted (if you have a B-news type
of
.IR inews
that understands -n and -t), depending whether
the message is marked private (email) or public (news).
.PP
.B uqwk
also supports a small offline command language, so the contents
of the user's .newsrc file can be viewed and manipulated offline.
.SH OPTIONS
.TP
.B +m
Do mail.
.B uqwk
will process all mail in the user's mail spool file and convert
it into a QWK packet.  This is the default.
.TP
.B -m
Don't do mail.
.TP
.B +n
Do news.  Using the user's .newsrc file and the news system's
active file,
.B uqwk
will collect all unread news articles in all subscribed newsgroups
into the QWK packet.  This can generate a large number of messages
and large QWK files.
.TP
.B -n
Don't do news.  This is the default.
.TP
.B +h
Include headers.  Since the QWK specification places limits on
the sizes of certain header fields such as To:, From:, and Subject:,
.B uqwk
can include all message and article headers in the body of the
message so all fields are visible.  This does not, however, make
it possible to successfully send a message to an email address
which consists of more that 25 characters.  This is the default.
.TP
.B -h
Do not include headers in messages.
.TP
.B -p
Print options.
.B uqwk
will examine all appropriate environment variables and command
line options, print the values of all run-time options, then exit.  This
is useful to see what
.B uqwk
thinks it is going to do before you actually run it.
.TP
.B +r
Read only.  Normally,
.B uqwk
will empty the user's mail spool file and update the user's .newsrc
file to reflect the fact that mail and news have been
read.  If this switch is specified,
.B uqwk
will not touch these files.  This is useful for testing.
.TP
.B -r
Do not execute in read-only mode.  This is the default.
.TP
.B -M\fImaildir\fR
Look in the directory \fImaildir\fR for the mail spool file.  The
default is /usr/spool/mail.
.TP
.B -f\fImailfile\fR
Look for mail in the file \fImailfile\fR.  The default is a file
with the same name as the user's login name in \fImaildir\fR.
This switch overrides the
.B -M
switch.
.TP
.B -u\fIusername\fR
By default
.B uqwk
uses the getpwuid() system call to determine the proper user
name to use.  This switch overrides the results of that call.
.TP
.B -H\fIhomedir\fR
By default,
.B uqwk
uses the getpwuid() system call to determine the user's home
directory.  The home directory is where the files comprising
the QWK packet will be created.  It is also where
.B uqwk
looks for the .newsrc file.  This switch may be used to
override the results of the getpwuid() call.
.TP
.B -b\fIbbsname\fR
Specify the BBS Name to be entered into the QWK packet.  The default
is "unknown BBS".
.TP
.B -c\fIcity\fR
Specify the BBS City to be entered into the QWK packet.  The default
is "Anytown, USA".
.TP
.B -P\fIphone\fR
Specify the BBS Phone Number to be entered into the QWK packet.
The default is "555-1212".
.TP
.B -s\fIsysop\fR
Specify the BBS Sysop Name to be entered into the QWK packet.  The
default is "Joe Sysop".
.TP
.B -i\fIbbsid\fR
Specify the BBS ID to be entered into the QWK packet.  The BBS ID
is important since it will be checked against the BBS ID string
in any incoming reply packets.  If the two do not match, the reply
packet will not be processed.  The BBS ID consists of an integer,
a comma, and a string of less than nine characters, with no spaces.
The default is "0,SOMEBBS".
.TP
.B -a\fIactivefile\fR
Use \fIactivefile\fR for the list of all available newsgroups and
article numbers.  The default is /usr/lib/news/active.
.TP
.B -N\fInewsrcfile\fR
Use \fInewsrcfile\fR for the list of all newsgroups to which the
user is subscribed and the list of article numbers which have been
read.  The default is a file called ".newsrc" in the user's home
directory.
.TP
.B -S\fInewsdir\fR
Look for news articles in the directory \fInewsdir\fR.  The default
is /usr/spool/news.
.TP
.B -B\fImaxblocks\fR
Stop processing news articles if the size of the QWK packet
(specifically, messages.dat) exceeds \fImaxblocks\fR 128-byte blocks.
This is useful since large amounts of unread news can create large
QWK files.  Use a \fImaxblocks\fR value of zero to suppress this
check.  The default is 4000 blocks (half a megabyte).
.TP
.B -R\fIreplyfile\fR
Process \fIreplyfile\fR as a reply packet.  Messages and articles
created by the offline reader must be uploaded as a reply packet
and then processed by this switch to be mailed or posted.
.B uqwk
will remove \fIreplyfile\fR when it has been processed unless
it is running in read-only mode.
.SH "ENVIRONMENT VARIABLES"
Most of the run-time options can also be controlled by
environment variables.  If an option is specified by both
an environment variable and a command-line option, the
command-line option is honored.
.TP
.B UQ_DO_MAIL
Determines whether or not to process mail.  Should be set to
"1" (do mail) or "0" (don't do mail).
.TP
.B UQ_DO_NEWS
Determines whether or not to process news.  Should be set to
"1" (do news) or "0" (don't do news).
.TP
.B UQ_INC_HDRS
Determines whether or not to include headers in messages.
Should be set to "1" (include headers) or "0" (don't include
headers).
.TP
.B UQ_PRT_OPTS
Determines whether or not to just print the values of run-time
options and stop.  Should be set to "1" (print options) or
"0" (don't print options).
.TP
.B UQ_READ_ONLY
Determines whether or not to run in read-only mode.  Should be
set to "1" (read-only) or "0" (not read-only).
.TP
.B UQ_MAIL_DIR
Specifies the directory where the mail spool file resides.
.TP
.B UQ_MAIL_FILE
Specifies the mail spool file.
.TP
.B UQ_USER_NAME
Specifies the username of the person running
.B uqwk.
.TP
.B UQ_HOME_DIR
Specifies the home directory, where the QWK files will be
created, and where
.B uqwk
expects to find the .newsrc file.
.TP
.B UQ_BBS_NAME
Specifies the BBS name to be entered into the QWK packet.
.TP
.B UQ_BBS_CITY
Specifies the BBS city to be entered into the QWK packet.
.TP
.B UQ_BBS_PHONE
Specifies the BBS phone number to be entered into the QWK packet.
.TP
.B UQ_BBS_SYSOP
Specifies the BBS sysop name to be entered into the QWK packet.
.TP
.B UQ_BBS_ID
Specifies the BBS ID to be entered into the QWK packet.
.TP
.B UQ_ACT_FILE
Specifies the name of the news system's active file.
.TP
.B UQ_NRC_FILE
Specifies the name of the user's .newsrc file.
.TP
.B UQ_REP_FILE
Specifies the name of the reply packet, if any.
.SH "COMMAND LANGUAGE"
If, while processing a reply packet,
.B uqwk
encounters a message to the username "UQWK", the body of the
message will be interpreted as a small command language, used
to display newsgroup names and subscribe or unsubscribe to
newsgroups.  The results of the execution of the commands will
be mailed back to the originating user.
.PP
This is what the command language looks like:
.TP
.B HELP
List all the available commands.
.TP
.B SUBSCRIBE newsgroup
Subscribe to the named newsgroup.
.TP
.B UNSUBSCRIBE newsgroup
Unsubscribe from the named newsgroup.  UNSUBSCRIBE ALL may be used to
unsubscribe from all newsgroups.  UNSUBSCRIBE ALL is also the only way
to create a new .newsrc if it does not already exist.
.TP
.B GROUPS
List all newsgroups to which the user is currently subscribed.
.TP
.B ALLGROUPS
List all the available newsgroups and the number of articles in
each one.
.SH BUGS
Karl J. Vesterling reported that some .newsrc files cause a core dump.
This may be related to the size of the .newsrc file or to long
lines in the file.  I was unable to reproduce the problem.  Increasing
BUF_LEN in uqwk.h may help.
.SH "SEE ALSO"
.PD
.BR mail(1),
.BR inews(8)
.SH ACKNOWLEDGEMENTS
Thanks to Patrick Y. Lee (patlee@panix.com) for the QWK documentation.
Many thanks also to the beta-testers:  Karl J. Vesterling
(kjv@exucom.com) and Brian J. Coan (brian@igc.apc.org).
.SH AUTHOR
Steve Belczyk, steve1@genesis.nred.ma.us, seb3@gte.com.
.PP
Copyright (C) 1993 by Steve Belczyk.
Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.  This software is provided "as is" without express or
implied warranty.
